//+------------------------------------------------------------------+
//|                                                 ATR_Smoothed.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int       ATRPeriod=120;
extern int       ATR_Smooth_Period=5;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexDrawBegin(0,ATRPeriod+ATR_Smooth_Period);
   SetIndexDrawBegin(1,ATRPeriod+ATR_Smooth_Period);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i,limit,limit2;
//----
   if (counted_bars==0) 
      {
      limit=Bars-ATRPeriod;
      limit2=limit-ATR_Smooth_Period;
      }
   if (counted_bars>0) 
      {
      limit=Bars-counted_bars;
      limit2=limit;
      }
   for (i=limit;i>=0;i--)
      {
      ExtMapBuffer1[i]=iATR(NULL,0,ATRPeriod,i);
      }
   for (i=limit2;i>=0;i--)
      {
      ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer1,0,ATR_Smooth_Period,0,MODE_SMA,i);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+